libstdc++: __gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » Branch-Based

`#include <assoc_container.hpp>`

Inheritance diagram for __gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >:
[legend]

## Public Types
typedef Node_Update | node_update

## Protected Member Functions
| basic_branch (const basic_branch &other)
template<typename T0>
| basic_branch (T0 t0)
template<typename T0, typename T1>
| basic_branch (T0 t0, T1 t1)
template<typename T0, typename T1, typename T2>
| basic_branch (T0 t0, T1 t1, T2 t2)
template<typename T0, typename T1, typename T2, typename T3>
| basic_branch (T0 t0, T1 t1, T2 t2, T3 t3)
template<typename T0, typename T1, typename T2, typename T3, typename T4>
| basic_branch (T0 t0, T1 t1, T2 t2, T3 t3, T4 t4)
template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
| basic_branch (T0 t0, T1 t1, T2 t2, T3 t3, T4 t4, T5 t5)
template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
| basic_branch (T0 t0, T1 t1, T2 t2, T3 t3, T4 t4, T5 t5, T6 t6)

## Detailed Description

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
class __gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >

A branched, tree-like (tree, trie) container abstraction.

Template Parameters

  Key | Key type.
  Mapped | Map type.
  Tag | Instantiating data structure type, see container_tag.
  Node_Update | Updates nodes, restores invariants.
  Policy_TL | Policy typelist.
  _Alloc | Allocator type.

Base is dispatched at compile time via Tag, from the following choices: tree_tag, trie_tag, and their descendants.

Base choices are: detail::ov_tree_map, detail::rb_tree_map, detail::splay_tree_map, and detail::pat_trie_map.

Definition at line 555 of file assoc_container.hpp.

## Member Typedef Documentation

## ◆ node_update

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>

typedef Node_Update __gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::node_update

Definition at line 561 of file assoc_container.hpp.

## Constructor & Destructor Documentation

## ◆ ~basic_branch()

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>

virtual __gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::~basic_branch | ( |  | ) |
| inlinevirtual

Definition at line 564 of file assoc_container.hpp.

## ◆ basic_branch() [1/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( |  | ) |
| inlineprotected

Definition at line 567 of file assoc_container.hpp.

## ◆ basic_branch() [2/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | const basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc > & | other | ) |
| inlineprotected

Definition at line 569 of file assoc_container.hpp.

## ◆ basic_branch() [3/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0 | ) |
| inlineprotected

Definition at line 573 of file assoc_container.hpp.

## ◆ basic_branch() [4/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1 )
| inlineprotected

Definition at line 576 of file assoc_container.hpp.

## ◆ basic_branch() [5/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1, typename T2>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1,
|  | T2 | t2 )
| inlineprotected

Definition at line 579 of file assoc_container.hpp.

## ◆ basic_branch() [6/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1, typename T2, typename T3>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1,
|  | T2 | t2,
|  | T3 | t3 )
| inlineprotected

Definition at line 582 of file assoc_container.hpp.

## ◆ basic_branch() [7/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1, typename T2, typename T3, typename T4>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1,
|  | T2 | t2,
|  | T3 | t3,
|  | T4 | t4 )
| inlineprotected

Definition at line 586 of file assoc_container.hpp.

## ◆ basic_branch() [8/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1,
|  | T2 | t2,
|  | T3 | t3,
|  | T4 | t4,
|  | T5 | t5 )
| inlineprotected

Definition at line 591 of file assoc_container.hpp.

## ◆ basic_branch() [9/9]

template<typename Key, typename Mapped, typename Tag, typename Node_Update, typename Policy_Tl, typename _Alloc>
template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>

__gnu_pbds::basic_branch< Key, Mapped, Tag, Node_Update, Policy_Tl, _Alloc >::basic_branch | ( | T0 | t0,
|  | T1 | t1,
|  | T2 | t2,
|  | T3 | t3,
|  | T4 | t4,
|  | T5 | t5,
|  | T6 | t6 )
| inlineprotected

Definition at line 596 of file assoc_container.hpp.

The documentation for this class was generated from the following file:

- assoc_container.hpp